program kartoteka;
type THuman = record
       name, surname: string;
       age: byte;
     end;
     TStack = ^TStackitem;
     TStackItem = record
      obsah:THuman;
      dalsi:TStack;
     end;
     TDataFile = file of THuman;
var f:text;
    zas:TStack;
    hledany:THuman;
    df:TDataFile;
function isEmpty(data:TStack):boolean;
begin
 isEmpty:= data=nil;
end;

procedure stackInit(var data:TStack);
var t : TStack;
begin
  if (not(isEmpty(data))) then begin
    while (data <> nil) do begin
      t := data^.dalsi;
      dispose(data);
      data := t;
    end;
  end
  else data:=nil;
end;


procedure push(var item:THuman;var data:TStack);
var it:TStack;
begin
  new(it);
  it^.obsah := item;
  it^.dalsi := data;
  data := it;
end;

function pop(var item:THuman;var data:TStack):boolean;
var pom:TStack;
begin
  if isEmpty(data) then pop:=false
  else begin
    item:=data^.obsah;
    pom:=data;
    data:=data^.dalsi;
    dispose(pom);
    pop:=true;
  end;
end;


procedure load(var f:text;var data:TStack);
var line: string;
    human:THuman;
  procedure parse(line:string; var human:THuman);
    var pom:string;
        p:integer;
    begin
     p:=pos(',',line);
     if(p>0) then
     begin
      human.name:=copy(line,1,p-1);
      line:=copy(line,p+1,length(line));
     end;
     p:=pos(',',line);
     if(p>0) then
     begin
      human.surname:=copy(line,1,p-1);
      line:=copy(line,p+1,length(line));
     end;
     val(line,human.age,p);
    end;
begin
  while (not eof(f)) do
  begin
    readln(f,line);
    parse(line,human);
    push(human,data);
  end;
end;

procedure search(data:TStack;var val:THuman);
var pom:TStack;
begin
  pom:=data;
  while ((pom<>nil)and((pom^.obsah.name<>val.name)or(pom^.obsah.surname<>val.surname))) do
  pom:=pom^.dalsi;
  if pom<>nil then val:=pom^.obsah;
end;

procedure saveType(var f:TDataFile;data:TStack);
begin
 rewrite(f);
 while (data<>nil) do begin
  write(f,data^.obsah);
  data:=data^.dalsi;
 end;
end;

procedure saveText(var f:text;data:TStack);
begin
 rewrite(f);
 while(data <> nil) do begin
   writeln(f, data^.obsah.name, ',',
   data^.obsah.surname, ',',
   data^.obsah.age);
   data := data^.dalsi;
 end;
end;

begin
 assign(f,'vstup.txt');
 assign(df,'vystup.dat');
 stackInit(zas);
 reset(f);
 load(f,zas);
 writeln('Zadejte hledanou osobu:');
 write('Jmeno:');
 readln(hledany.name);
 write('Prijmeni:');
 readln(hledany.surname);
 hledany.age:=0;
 search(zas,hledany);
 close(f);
 assign(f,'vystup.txt');
 writeln(' vek:',hledany.age);
 saveText(output,zas);
 saveType(df,zas);
 close(df);
 saveText(f,zas);
 stackInit(zas);
 close(f);
end.
